
#include "Handle.h"


WCHAR *stristrW(WCHAR *Str, WCHAR *Pat)
{
    WCHAR *pptr, *sptr, *start;

    for (start = (WCHAR *)Str; *start != '\0'; start++)
    {
        for ( ; ((*start!='\0') && (toupper(*start) != toupper(*Pat))); start++);
        if ('\0' == *start) return NULL;
        pptr = (WCHAR *)Pat;
        sptr = (WCHAR *)start;
        while (toupper(*sptr) == toupper(*pptr))
        {
            sptr++;
            pptr++;
            if ('\0' == *pptr) return (start);
        }
    }
    return NULL;
}

//==============================================================================

VOID HandleList(DWORD pid)
{
    NTSTATUS                   status;
    PSYSTEM_HANDLE_INFORMATION handleInfo;
    ULONG                      handleInfoSize = 0x10000;
    HANDLE                     processHandle;
    ULONG                      i;
    
    _NtQuerySystemInformation NtQuerySystemInformation = GetLibraryProcAddress("ntdll.dll", "NtQuerySystemInformation");
    _NtDuplicateObject        NtDuplicateObject        = GetLibraryProcAddress("ntdll.dll", "NtDuplicateObject");
    _NtQueryObject            NtQueryObject            = GetLibraryProcAddress("ntdll.dll", "NtQueryObject");

    if(!(processHandle = OpenProcess(PROCESS_DUP_HANDLE|PROCESS_QUERY_INFORMATION|PROCESS_VM_READ,FALSE,pid))) return;

    handleInfo = (PSYSTEM_HANDLE_INFORMATION)malloc(handleInfoSize);

    while((status = NtQuerySystemInformation(SystemHandleInformation,handleInfo,handleInfoSize,NULL)) == STATUS_INFO_LENGTH_MISMATCH)
    handleInfo = (PSYSTEM_HANDLE_INFORMATION)realloc(handleInfo, handleInfoSize *= 2);

    if(!NT_SUCCESS(status)) return;
    
    for(i = 0; i < handleInfo->HandleCount; i++)
    {
        SYSTEM_HANDLE handle     = handleInfo->Handles[i];
        HANDLE dupHandle         = NULL;
        POBJECT_TYPE_INFORMATION objectTypeInfo;
        PVOID                    objectNameInfo;
        UNICODE_STRING           objectName;
        ULONG                    returnLength;

        if(handle.ProcessId != pid) continue;
        if(!NT_SUCCESS(NtDuplicateObject(processHandle,(HANDLE)handle.Handle,GetCurrentProcess(),&dupHandle,0,0,0))) continue;
        objectTypeInfo = (POBJECT_TYPE_INFORMATION)malloc(0x1000);

        if(!NT_SUCCESS(NtQueryObject(dupHandle,ObjectTypeInformation,objectTypeInfo,0x1000,NULL)))
        {
            CloseHandle(dupHandle);
            continue;
        }

        if((handle.GrantedAccess != 0x0012019f)
        && (handle.GrantedAccess != 0x001a019f)
        && (handle.GrantedAccess != 0x00120189)
        && (handle.GrantedAccess != 0x00100000))
        {
            wprintf(L"%s - 0x%X - ",objectTypeInfo->Name.Buffer, handle.Handle);
            //wprintf(L"0x%X",handle.GrantedAccess);

            objectNameInfo = malloc(0x1000);
            if(!NT_SUCCESS(NtQueryObject(dupHandle,ObjectNameInformation,objectNameInfo,0x1000,&returnLength)))
            {
                objectNameInfo = realloc(objectNameInfo, returnLength);
                if(!NT_SUCCESS(NtQueryObject(dupHandle,ObjectNameInformation,objectNameInfo,returnLength,NULL)))
                {
                    free(objectTypeInfo);
                    free(objectNameInfo);
                    CloseHandle(dupHandle);
                    continue;
                }
            }
            objectName = *(PUNICODE_STRING)objectNameInfo;

            if(objectName.Length) wprintf(L"%s",objectName.Buffer);
            else wprintf(L"\0");
            
            wprintf(L"\n");
        }
        free(objectTypeInfo);
        free(objectNameInfo);
        CloseHandle(dupHandle);
    }
    free(handleInfo);
    CloseHandle(processHandle);
    return;
}

//==============================================================================

int main()
{
    DWORD PID;
    WCHAR PN[MAX_PATH]={0};
    
    for(PID = 0;PID < 0xFFFF; PID +=4)
    {
        HANDLE hP = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, 0, PID);
        if(hP)
        {
            GetModuleBaseNameW(hP, NULL, PN, sizeof(PN));
            if(stristrW(PN, L"explorer.exe")) HandleList(PID);
        }
        CloseHandle(hP);
    }
    system("pause");
}
